PF-build.sh 43 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826827828829830831832833834835836837838839840841842843844845846847848849850851852853854855856857858859860861862863864865866867868869870871872873874875876877878879880881882883884885886887888889890891892893894895896897898899900901902903904905906907908909910911912913914915916917918919920921922923924925926
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_33
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. #### Start check if OSTYPE is supported
  139. OS_FOUND=$( command -v uname)
  140. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  141. linux*)
  142. TARGET_OS="linux"
  143. ;;
  144. msys*|cygwin*|mingw*)
  145. # or possible 'bash on windows'
  146. TARGET_OS='windows'
  147. ;;
  148. nt|win*)
  149. TARGET_OS='windows'
  150. ;;
  151. *)
  152. TARGET_OS='unknown'
  153. ;;
  154. esac
  155. # Windows
  156. if [ $TARGET_OS == "windows" ]; then
  157. if [ $(uname -m) == "x86_64" ]; then
  158. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  159. Processor="64"
  160. elif [ $(uname -m) == "i386" ]; then
  161. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  162. Processor="32"
  163. else
  164. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  165. echo "Please refer to the notes of build.sh$(tput sgr0)"
  166. exit 1
  167. fi
  168. # Linux
  169. elif [ $TARGET_OS == "linux" ]; then
  170. if [ $(uname -m) == "x86_64" ]; then
  171. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  172. Processor="64"
  173. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  174. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  175. Processor="32"
  176. else
  177. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  178. echo "Please refer to the notes of build.sh$(tput sgr0)"
  179. exit 1
  180. fi
  181. else
  182. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  183. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  184. echo "Read the notes of build.sh$(tput sgr0)"
  185. exit 1
  186. fi
  187. sleep 2
  188. #### End check if OSTYPE is supported
  189. #### Prepare bash environment and check if wget, zip and other needed things are available
  190. # Check wget
  191. if ! type wget > /dev/null; then
  192. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  193. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  194. exit 2
  195. fi
  196. # Check for zip
  197. if ! type zip > /dev/null; then
  198. if [ $TARGET_OS == "windows" ]; then
  199. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  200. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  201. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  202. echo "Run git Bash under Administrator privilege and"
  203. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  204. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  205. exit 3
  206. elif [ $TARGET_OS == "linux" ]; then
  207. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  208. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  209. #sudo apt-get update && apt-get install zip
  210. exit 3
  211. fi
  212. fi
  213. # Check python ... needed during language build
  214. if ! type python > /dev/null; then
  215. if [ $TARGET_OS == "windows" ]; then
  216. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  217. exit 4
  218. elif [ $TARGET_OS == "linux" ]; then
  219. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  220. echo "As Python 2.x will not be maintained from 2020 please,"
  221. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  222. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  223. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  224. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  225. exit 4
  226. fi
  227. fi
  228. # Check gawk ... needed during language build
  229. if ! type gawk > /dev/null; then
  230. if [ $TARGET_OS == "linux" ]; then
  231. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  232. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  233. #sudo apt-get update && apt-get install gawk
  234. exit 4
  235. fi
  236. fi
  237. #### End prepare bash / Linux environment
  238. #### Set build environment
  239. ARDUINO_ENV="1.8.5"
  240. BUILD_ENV="1.0.6"
  241. BOARD="prusa_einsy_rambo"
  242. BOARD_PACKAGE_NAME="PrusaResearch"
  243. BOARD_VERSION="1.0.3"
  244. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  245. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  246. BOARD_FILENAME="prusa3dboards"
  247. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  248. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  249. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  250. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  251. LIB="PrusaLibrary"
  252. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  253. # List few useful data
  254. echo
  255. echo "Script path :" $SCRIPT_PATH
  256. echo "OS :" $OS
  257. echo "OS type :" $TARGET_OS
  258. echo ""
  259. echo "Arduino IDE :" $ARDUINO_ENV
  260. echo "Build env :" $BUILD_ENV
  261. echo "Board :" $BOARD
  262. echo "Package name:" $BOARD_PACKAGE_NAME
  263. echo "Board v. :" $BOARD_VERSION
  264. echo "Specific Lib:" $LIB
  265. echo ""
  266. #### Start prepare building environment
  267. #Check if build exists and creates it if not
  268. if [ ! -d "../PF-build-dl" ]; then
  269. mkdir ../PF-build-dl || exit 5
  270. fi
  271. cd ../PF-build-dl || exit 6
  272. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  273. # Check if PF-build-env-<version> exists and downloads + creates it if not
  274. # The build environment is based on the supported Arduino IDE portable version with some changes
  275. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  276. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  277. mkdir ../PF-build-env-$BUILD_ENV
  278. sleep 5
  279. fi
  280. # Download and extract supported Arduino IDE depending on OS
  281. # Windows
  282. if [ $TARGET_OS == "windows" ]; then
  283. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  284. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  285. sleep 2
  286. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  287. echo "$(tput sgr 0)"
  288. fi
  289. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  290. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  291. sleep 2
  292. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  293. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  294. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  295. echo "$(tput sgr0)"
  296. fi
  297. fi
  298. # Linux
  299. if [ $TARGET_OS == "linux" ]; then
  300. # 32 or 64 bit version
  301. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  302. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  303. sleep 2
  304. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  305. echo "$(tput sgr 0)"
  306. fi
  307. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  308. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  309. sleep 2
  310. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  311. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  312. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  313. echo "$(tput sgr0)"
  314. fi
  315. fi
  316. # Make Arduino IDE portable
  317. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  318. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  319. fi
  320. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  321. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  322. fi
  323. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  324. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  325. fi
  326. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  327. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  328. fi
  329. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  330. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  331. fi
  332. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  333. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  334. fi
  335. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  336. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  337. fi
  338. # Change Arduino IDE preferences
  339. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  340. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  341. sleep 2
  342. echo "update.check"
  343. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  344. echo "board"
  345. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  346. echo "editor.linenumbers"
  347. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  348. echo "boardsmanager.additional.urls"
  349. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  350. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  351. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  352. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  353. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  354. echo "$(tput sgr0)"
  355. fi
  356. # Download and extract Prusa Firmware related parts
  357. # Download and extract PrusaResearchRambo board
  358. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  359. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  360. sleep 2
  361. wget $BOARD_FILE_URL || exit 9
  362. fi
  363. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  364. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  365. sleep 2
  366. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  367. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  368. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  369. fi
  370. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  371. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  372. fi
  373. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  374. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  375. fi
  376. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  377. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  378. fi
  379. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  380. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  381. echo "$(tput sgr 0)"
  382. fi
  383. # Download and extract Prusa Firmware specific library files
  384. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  385. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  386. sleep 2
  387. wget $PF_BUILD_FILE_URL || exit 11
  388. echo "$(tput sgr 0)"
  389. fi
  390. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  391. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  392. sleep 2
  393. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  394. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  395. echo "$(tput sgr0)"
  396. fi
  397. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  398. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  399. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  400. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  401. sleep 2
  402. fi
  403. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  404. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  405. sleep 2
  406. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  407. sleep 2
  408. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  409. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  410. echo "$(tput sgr0)"
  411. fi
  412. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  413. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  414. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  415. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  416. sleep 2
  417. echo "$(tput sgr0)"
  418. exit 13
  419. fi
  420. #### End prepare building
  421. #### Start
  422. cd $SCRIPT_PATH
  423. # Check if git is available
  424. if type git > /dev/null; then
  425. git_available="1"
  426. fi
  427. while getopts v:l:d:b:o:?h flag
  428. do
  429. case "${flag}" in
  430. v) variant_flag=${OPTARG};;
  431. l) language_flag=${OPTARG};;
  432. d) devel_flag=${OPTARG};;
  433. b) build_flag=${OPTARG};;
  434. o) output_flag=${OPTARG};;
  435. ?) help_flag=1;;
  436. h) help_flag=1;;
  437. esac
  438. done
  439. #echo "variant_flag: $variant_flag";
  440. #echo "language_flag: $language_flag";
  441. #echo "devel_flag: $devel_flag";
  442. #echo "build_flag: $build_flag";
  443. #echo "output_flag: $output_flag";
  444. #echo "help_flag: $help_flag"
  445. #
  446. # '?' 'h' argument usage and help
  447. if [ "$help_flag" == "1" ] ; then
  448. echo "***************************************"
  449. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  450. echo "***************************************"
  451. echo "Arguments:"
  452. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  453. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  454. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  455. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  456. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  457. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  458. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  459. echo
  460. echo "Brief USAGE:"
  461. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-v] [-l] [-d] [-b] [-o]"
  462. echo
  463. echo "Example:"
  464. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  465. echo " Will build all variants as multi language and final GOLD version"
  466. echo
  467. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1$(tput sgr0)"
  468. echo " Will build MK3S multi language final GOLD firmware "
  469. echo " with current commit count number and output extra information"
  470. echo
  471. exit
  472. fi
  473. #
  474. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  475. if [ -z "$variant_flag" ] ; then
  476. # Select which variant of the Prusa Firmware will be compiled, like
  477. PS3="Select a variant: "
  478. while IFS= read -r -d $'\0' f; do
  479. options[i++]="$f"
  480. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  481. select opt in "${options[@]}" "All" "Quit"; do
  482. case $opt in
  483. *.h)
  484. VARIANT=$(basename "$opt" ".h")
  485. VARIANTS[i++]="$opt"
  486. break
  487. ;;
  488. "All")
  489. VARIANT="All"
  490. VARIANTS=${options[*]}
  491. break
  492. ;;
  493. "Quit")
  494. echo "You chose to stop"
  495. exit 20
  496. ;;
  497. *)
  498. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  499. ;;
  500. esac
  501. done
  502. else
  503. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  504. VARIANTS=$variant_flag
  505. elif [ "$variant_flag" == "All" ] ; then
  506. while IFS= read -r -d $'\0' f; do
  507. options[i++]="$f"
  508. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  509. VARIANT="All"
  510. VARIANTS=${options[*]}
  511. else
  512. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  513. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  514. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  515. echo "$(tput sgr0)"
  516. exit 21
  517. fi
  518. fi
  519. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  520. #Check default language mode
  521. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  522. if [ -z "$language_flag" ] ; then
  523. PS3="Select a language: "
  524. echo
  525. echo "Which lang-build do you want?"
  526. select yn in "Multi languages" "English only"; do
  527. case $yn in
  528. "Multi languages")
  529. LANGUAGES="ALL"
  530. break
  531. ;;
  532. "English only")
  533. LANGUAGES="EN_ONLY"
  534. break
  535. ;;
  536. *)
  537. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  538. ;;
  539. esac
  540. done
  541. else
  542. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  543. LANGUAGES=$language_flag
  544. else
  545. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  546. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  547. exit 22
  548. fi
  549. fi
  550. #Check if DEV_STATUS is selected via argument '-d'
  551. if [ ! -z "$devel_flag" ] ; then
  552. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  553. DEV_STATUS_SELECTED=$devel_flag
  554. else
  555. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  556. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  557. exit 23
  558. fi
  559. fi
  560. #Check if Build is selected via argument '-b'
  561. if [ ! -z "$build_flag" ] ; then
  562. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  563. echo "Build changed to $build_flag"
  564. BUILD=$(git rev-list --count HEAD)
  565. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  566. BUILD=$build_flag
  567. else
  568. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  569. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  570. exit 24
  571. fi
  572. echo "New Build number is: $BUILD"
  573. fi
  574. # check if script has been started with arguments
  575. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  576. OUTPUT=1
  577. else
  578. OUTPUT=0
  579. fi
  580. #echo "Output is:" $OUTPUT
  581. #Check git branch has changed
  582. if [ ! -z "git_available" ]; then
  583. BRANCH=""
  584. CLEAN_PF_FW_BUILD=0
  585. else
  586. BRANCH=$(git branch --show-current)
  587. echo "Current branch is:" $BRANCH
  588. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  589. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  590. echo "created PF-build.branch file"
  591. else
  592. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  593. echo "Previous branch was:" $PRE_BRANCH
  594. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  595. CLEAN_PF_FW_BUILD=1
  596. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  597. fi
  598. fi
  599. fi
  600. #Set BUILD_ENV_PATH
  601. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 25
  602. BUILD_ENV_PATH="$( pwd -P )"
  603. cd ../..
  604. #Checkif BUILD_PATH exists and if not creates it
  605. if [ ! -d "Prusa-Firmware-build" ]; then
  606. mkdir Prusa-Firmware-build || exit 26
  607. fi
  608. #Set the BUILD_PATH for Arduino IDE
  609. cd Prusa-Firmware-build || exit 27
  610. BUILD_PATH="$( pwd -P )"
  611. #Check git branch has changed
  612. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  613. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  614. rm -r *
  615. else
  616. echo "Nothing to clean up"
  617. fi
  618. for v in ${VARIANTS[*]}
  619. do
  620. VARIANT=$(basename "$v" ".h")
  621. # Find firmware version in Configuration.h file and use it to generate the hex filename
  622. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  623. if [ -z "$BUILD" ] ; then
  624. # Find build version in Configuration.h file and use it to generate the hex filename
  625. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  626. else
  627. # Find and replace build version in Configuration.h file
  628. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  629. echo "Original build number: $BUILD_ORG"
  630. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  631. fi
  632. # Check if the motherboard is an EINSY and if so only one hex file will generated
  633. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  634. # Check development status
  635. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  636. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  637. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  638. DEV_STATUS="RC"
  639. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  640. DEV_STATUS="ALPHA"
  641. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  642. DEV_STATUS="BETA"
  643. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  644. DEV_STATUS="DEVEL"
  645. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  646. DEV_STATUS="DEBUG"
  647. else
  648. DEV_STATUS="UNKNOWN"
  649. echo
  650. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  651. PS3="Select YES only if source code is tested and trusted: "
  652. select yn in "Yes" "No"; do
  653. case $yn in
  654. Yes)
  655. DEV_STATUS="GOLD"
  656. DEV_STATUS_SELECTED="GOLD"
  657. break
  658. ;;
  659. No)
  660. DEV_STATUS="UNKNOWN"
  661. DEV_STATUS_SELECTED="UNKNOWN"
  662. break
  663. ;;
  664. *)
  665. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  666. ;;
  667. esac
  668. done
  669. fi
  670. else
  671. DEV_STATUS=$DEV_STATUS_SELECTED
  672. fi
  673. #Prepare hex files folders
  674. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  675. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 28
  676. fi
  677. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  678. #Check if exactly the same hexfile already exists
  679. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  680. echo ""
  681. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  682. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  683. if [ $OUTPUT == "1" ] ; then
  684. read -t 10 -p "Press Enter to continue..."
  685. fi
  686. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  687. echo ""
  688. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  689. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  690. if [ $OUTPUT == "1" ] ; then
  691. read -t 10 -p "Press Enter to continue..."
  692. fi
  693. fi
  694. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  695. echo ""
  696. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  697. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  698. if [ $OUTPUT == "1" ] ; then
  699. read -t 10 -p "Press Enter to continue..."
  700. fi
  701. fi
  702. #List some useful data
  703. echo "$(tput setaf 2)$(tput setab 7) "
  704. echo "Variant :" $VARIANT
  705. echo "Firmware :" $FW
  706. echo "Build # :" $BUILD
  707. echo "Dev Check :" $DEV_CHECK
  708. echo "DEV Status :" $DEV_STATUS
  709. echo "Motherboard:" $MOTHERBOARD
  710. echo "Languages :" $LANGUAGES
  711. echo "Hex-file Folder:" $OUTPUT_FOLDER
  712. echo "$(tput sgr0)"
  713. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  714. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  715. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  716. else
  717. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  718. if [ $OUTPUT == "1" ] ; then
  719. read -t 10 -p "Press Enter to continue..."
  720. fi
  721. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 29
  722. fi
  723. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  724. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  725. # set FW_REPOSITORY
  726. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  727. #Prepare English only or multi-language version to be build
  728. if [ $LANGUAGES == "EN_ONLY" ]; then
  729. echo " "
  730. echo "English only language firmware will be built"
  731. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  732. echo " "
  733. else
  734. echo " "
  735. echo "Multi-language firmware will be built"
  736. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  737. echo " "
  738. fi
  739. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  740. # if [ $TARGET_OS == "windows" ]; then
  741. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  742. # fi
  743. #### End of Prepare building
  744. #### Start building
  745. export ARDUINO=$BUILD_ENV_PATH
  746. #echo $BUILD_ENV_PATH
  747. #export BUILDER=$ARDUINO/arduino-builder
  748. echo
  749. #read -t 5 -p "Press Enter..."
  750. echo
  751. echo "Start to build Prusa Firmware ..."
  752. echo "Using variant $VARIANT$(tput setaf 3)"
  753. if [ $OUTPUT == "1" ] ; then
  754. sleep 2
  755. fi
  756. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  757. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 30
  758. echo "$(tput sgr 0)"
  759. if [ $LANGUAGES == "ALL" ]; then
  760. echo "$(tput setaf 2)"
  761. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  762. echo "$(tput sgr 0)"
  763. if [ $OUTPUT == "1" ] ; then
  764. sleep 2
  765. fi
  766. cd $SCRIPT_PATH/lang
  767. echo "$(tput setaf 3)"
  768. ./config.sh || exit 31
  769. echo "$(tput sgr 0)"
  770. # Check if previous languages and firmware build exist and if so clean them up
  771. if [ -f "lang_en.tmp" ]; then
  772. echo ""
  773. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  774. if [ $OUTPUT == "1" ] ; then
  775. read -t 10 -p "Press Enter to continue..."
  776. fi
  777. echo "$(tput setaf 3)"
  778. ./lang-clean.sh
  779. echo "$(tput sgr 0)"
  780. fi
  781. if [ -f "progmem.out" ]; then
  782. echo ""
  783. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  784. if [ $OUTPUT == "1" ] ; then
  785. read -t 10 -p "Press Enter to continue..."
  786. fi
  787. echo "$(tput setaf 3)"
  788. ./fw-clean.sh
  789. echo "$(tput sgr 0)"
  790. fi
  791. # build languages
  792. echo "$(tput setaf 3)"
  793. ./lang-build.sh || exit 32
  794. # Combine compiled firmware with languages
  795. ./fw-build.sh || exit 33
  796. cp not_tran.txt not_tran_$VARIANT.txt
  797. cp not_used.txt not_used_$VARIANT.txt
  798. echo "$(tput sgr 0)"
  799. # Check if the motherboard is an EINSY and if so only one hex file will generated
  800. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  801. # If the motherboard is an EINSY just copy one hexfile
  802. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  803. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  804. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  805. else
  806. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  807. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  808. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  809. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  810. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  811. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  812. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  813. if [ $TARGET_OS == "windows" ]; then
  814. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  815. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  816. elif [ $TARGET_OS == "linux" ]; then
  817. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  818. fi
  819. fi
  820. # Cleanup after build
  821. echo "$(tput setaf 3)"
  822. ./fw-clean.sh || exit 34
  823. ./lang-clean.sh || exit 35
  824. echo "$(tput sgr 0)"
  825. else
  826. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  827. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  828. fi
  829. # Cleanup Firmware
  830. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  831. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  832. then
  833. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  834. fi
  835. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  836. then
  837. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  838. fi
  839. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  840. then
  841. rm $SCRIPT_PATH/lang/not_tran.txt
  842. fi
  843. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  844. then
  845. rm $SCRIPT_PATH/lang/not_used.txt
  846. fi
  847. # Restore files to previous state
  848. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  849. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  850. if [ ! -z "$BUILD_ORG" ] ; then
  851. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  852. fi
  853. echo $MULTI_LANGUAGE_CHECK
  854. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  855. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  856. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  857. if [ $OUTPUT == "1" ] ; then
  858. sleep 5
  859. fi
  860. done
  861. # Switch to hex path and list build files
  862. cd $SCRIPT_PATH
  863. cd ..
  864. echo "$(tput setaf 2) "
  865. echo " "
  866. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  867. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  868. #### End building